CoCoA-5 - Support #973

GroebnerFanldeals: verbosity and output style
17 Nov 2016 15:27 - John Abbott
Priority: High Due date:
Category: enhancing/improving Estimated time: 5.50 hours
Target version: CoCoA-5.2.0 spring 2017 Spent time: 5.55 hours
Description

Two mild criticisms:

e it prints out an asterisk for each fan ideal found
¢ the generators of the ideals are not monic (so they are not strictly ReducedGBasis)

Related issues:

Related to CoCoA-5 - Feature #903: New function CallOnGroebnerFanldeals: call... Closed 04 Jul 2016
Related to CoCoA-5 - Design #984: GroebnerFanldeals: order matrices sometimes... New 26 Nov 2016
Copied to CoCoA-5 - Support #977: "universal denominator" (related with Groeb... In Progress 17 Nov 2016
History

#1 - 17 Nov 2016 15:28 - John Abbott

| have given this a higher priority because | think it will be quick and easy to resolve.

@Anna: can you do it? (before releasing 5.1.67)

#2 - 17 Nov 2016 15:32 - John Abbott

| tried GroebnerFanldeals on the following input:

use P::=Q0Q([x,y,z];

I := ideal (x"5-3*y"3*z+x*y*z-2, y"3-2*z+5, z"2-12*x+7*y);
GF := GroebnerFanIdeals(I);
indent (GF) ;

The resulting list GF has 195 elements, but many of them seem to be repeats. Is this intended? (Or should there be another issue for this?)

NOTE comparing the printed forms of the ideals there are only 11 different results (perhaps ones that appear equal actually have different LPPs?)

#3 - 17 Nov 2016 16:25 - Anna Maria Bigatti

John Abbott wrote:
| tried GroebnerFanldeals on the following input:
(-]

The resulting list GF has 195 elements, but many of them seem to be repeats. Is this intended? (Or should there be another issue for this?)

NOTE comparing the printed forms of the ideals there are only 11 different results (perhaps ones that appear equal actually have different
LPPs?)
The function GroebnerFanldeals returns the IDEALS.
(Renzo's happy you had the same problem as his!)
Inside the ideals there are the GBases.

If you want them do

indent ([ReducedGBasis (J) | J in GroebnerFanIdeals(I)]);

It would be nice to have result the ideals generated by the reduced GBases, but in that way (in CoCoA-5!) we would lose that those are the GBases!
In CoCoALib we can declare that the generators are a GBasis, but in CoCoA-5 we cannot.
Should we allow that? (indeed it would be quite useful in a few places)

#4 - 17 Nov 2016 21:29 - Anna Maria Bigatti

- Related to Feature #903: New function CallOnGroebnerFanldeals: call function on GFan ideals added

#5 - 17 Nov 2016 22:52 - John Abbott
moved to #977

Does this code correctly compute the "universal denominator” for the ideal I? {...)

#6 - 18 Nov 2016 09:15 - Anna Maria Bigatti
- Subject changed from GroebnerFanlideals to GroebnerFanldeals: verbosity

- Assignee set to Anna Maria Bigatti

#7 - 18 Nov 2016 09:15 - Anna Maria Bigatti

- Subject changed from GroebnerFanlideals: verbosity to GroebnerFanldeals: verbosity and output style
#8 - 18 Nov 2016 22:02 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

moved to #977

Robbiano suggested that it could be interesting to find the first (or at least a smallish) good prime. (...)

#9 - 21 Nov 2016 09:33 - Anna Maria Bigatti
- Copied to Support #977: "universal denominator” (related with GroebnerFanldeals) added
#10 - 21 Nov 2016 09:40 - Anna Maria Bigatti
- % Done changed from 10 to 0

It would be nice to have as result the list of ideals generated by the reduced GBases, but in that way (in CoCoA-5!) we would lose that those
polynomials are the GBases!

In CoCoALib we can declare that the generators are a GBasis, but in CoCoA-5 we cannot.
Should we allow that in CoCoA-57? (indeed it would be quite useful in a few places)

#11 - 21 Nov 2016 14:27 - John Abbott

| think the confusion came from the way the documentation is worded.

| have rerun the example from comment 2, and can (fairly) safely say that no-one wants to see the reduced G-bases (the whole output was more than
2Mbytes).

What was not entirely clear to me was whether these ideals already had their reduced G-bases memorized inside, or whether the G-bases are
computed "on demand". Maybe it does not matter; maybe "on demand" is actually a better option, as | imagine non-trivial examples quickly give
gigantic results (i.e. the sum of the sizes of all the various G-bases).

I'm still amazed at how "ugly" some of the reduced G-bases are (i.e. the coeffs are very complicated).

#12 - 21 Nov 2016 14:44 - Anna Maria Bigatti
John Abbott wrote:

| think the confusion came from the way the documentation is worded.

| have rerun the example from comment 2, and can (fairly) safely say that no-one wants to see the reduced G-bases (the whole output was more
than 2Mbytes).

indeed.
What was not entirely clear to me was whether these ideals already had their reduced G-bases memorized inside, or whether the G-bases are

computed "on demand". Maybe it does not matter; maybe "on demand" is actually a better option, as | imagine non-trivial examples quickly give
gigantic results (i.e. the sum of the sizes of all the various G-bases).

This actually memorizes the GBases.
The clever function is "CallOnGroebnerFanldeals".

But it is true that the user gets confused. (both you and Robbiano were tricked by lists which were identical, but did NOT LOOK so)
One possibility, for small examples (or for convincing the user it is not a good idea ;-) is writing the function "GroebnerFanReducedGBases", which is
trivial to write, and exactly what the user expects (even though it is often not what he wants!)

Or maybe | should write some good examples in the manual?
#13 - 22 Nov 2016 07:36 - Anna Maria Bigatti

Anna Maria Bigatti wrote:
One possibility, for small examples (or for convincing the user it is not a good idea ;-) is writing the function "GroebnerFanReducedGBases"

Or maybe | should write some good examples in the manual?

| will do both: indeed I'll write a good example in the manual of the new function with an explicatory example.

#14 - 22 Nov 2016 11:25 - John Abbott
- % Done changed from 0 to 30

| have rewritten the man page for GroebnerFanldeals (and already checked in, if | recall correctly).

#15 - 22 Nov 2016 13:09 - John Abbott

Out of curiosity.... Does GFan produce order matrices with smallest possible non-negative entries?

In the example from comment 2, there are two order matrices with entries larger than 1000...

If negative entries are allowed then these number can be greatly reduced (though internally they are probably made non-negative again because of
the coding we use for order vectors).

#16 - 23 Nov 2016 08:53 - Anna Maria Bigatti
- % Done changed from 30 to 60
- Estimated time set to 5.00 h

Added GroebnerFanReducedGBases.

For the ™" | could use the new "VerbosityLevel". Working on it.

#17 - 23 Nov 2016 13:55 - Anna Maria Bigatti
- Status changed from In Progress to Feedback

- % Done changed from 60 to 90

nkn

Now prints "*" with verbosity >=10 /// updated

/**/ SetVerbosityLevel (10);
/**/ use R ::= QQla,b,cl;
/**/ 1 := ideal (b"2-1, a”2+c-1, c"2-b);
/**/ indent (GroebnerFanReducedGBases (I));
/**/ ****[
[c"2 -b, b*2 -1, a2 +c -11,
[b -c”2, a2 +c -1, c~4 -11,
[c +a”2 -1, b -a”4 +2*a”2 -1, a8 -4*a”6 +6*a"4 -4*a"2],
[c +ta®2 -1, b"2 -1, a”4 -b -2*a"2 +1]
#18 - 26 Nov 2016 17:51 - John Abbott

- Related to Design #984: GroebnerFanldeals: order matrices sometimes have "large" entries added

#19 - 02 Mar 2017 15:23 - Anna Maria Bigatti

now prints

e with verbosity >=10 (each call of recursive, CallOnRecursive)
. with verbosity >=20 (each call of GetFlippablelnequalities)
maxdeg with verbosity >=80 (GetFlippablelnequalities)
timings with verbosity >=90 (GroebnerFanldeals, CallOnGroebnerFanldeals)

#20 - 06 Mar 2017 17:45 - Anna Maria Bigatti

Now using IdealOfGBasis, so that the generators of the ideals are the different GBasis.

/**/ use R ::= QQla,b,cl;

/**/ I := ideal (b”2-1, a”2+c-1, c"2-b);

/**/ indent (GroebnerFanIdeals (I));

[
ideal
ideal
ideal
ideal

c*"2 -b, b*2 -1, a”2 +c -1),
b -¢*2, a*2 +c -1, c*4 -1),
c +a”*2 -1, b -a”4 +2*a”2 -1, a8 —-4*a”6 +6*a"4 -4*a"2),

(
(
(
(c +a”2 -1, b*2 -1, a4 -b -2*a”2 +1)

#21 - 28 Apr 2017 15:14 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time changed from 5.00 h to 5.50 h

This seems to work well now.
Sometimes it is slow, but | think that is GFan's fault.

Closing.
